/*
Scrivere un programma per la gestione delle informazioni relative ai soci di un'associazione. Ciascun socio e' caratterizzato dalle seguente informazioni: nome e cognome,  numero di tessera,  data di iscrizione (aaaa/mm/gg), categoria di appartenenza (0=ragazzi, 1=giovani, 2=adulti, 3=anziani).
Nel programma e' presente un men caratterizzato dalle seguenti funzioni:
 1) Inserimento di un nuovo socio;
 2) Visualizzazione del nome e cognome dei soci appartenenti a una certa categoria;
 3) Salvataggio su file dei soci con data di iscrizione antecedenti a una certa data;
 4) Lettura da file e visualizzazione dei soci precedentemente salvati.


*/

#include <stdio.h>
#include <string.h>

typedef struct
    { char nome[30],cognome[30];
      int ntessera,categoria;
	  char data[11];
	} socio;

void inserisci(socio *V,int *pn);
void visualizza(socio *V,int n);
void salva(socio *V,int n);
void visualizza_file();
void menu( );

int main( )
{ socio A[10];
  int scelta,n=0;

  do{
    menu( );
    scanf("%d",&scelta);
   switch(scelta){
	case 1: inserisci(A,&n);
		  break;
	case 2: visualizza(A,n);
		  break;
	case 3: salva(A,n);
		  break;
	case 4: visualizza_file();
		  break;
	default:;
		}
	}while(scelta!=0);

}


 void inserisci(socio *V,int *pn)
 {socio S;
  if(*pn<10)
	  { printf("Nome:\n ");
       scanf("%s",S.nome);
	   printf("Cognome:\n ");
	   scanf("%s",S.cognome);
	   printf("ntessera:\n ");
	   scanf("%d",&S.ntessera);
	   printf("Categoria:\n ");
	   scanf("%d",&S.categoria);
	   printf("Data:\n ");
	   scanf("%s",S.data);

	   V[*pn]=S;
       *pn=*pn+1;
	  }
	  else printf("Vettore pieno\n");

 }

void visualizza(socio *V,int n)
 {int i,categoria;

   printf("quale categoria?\n");
   scanf("%d",&categoria);

   for(i=0;i<n;i++)
	  if(V[i].categoria==categoria)
		{  printf("%s\n",V[i].nome);
	       printf("%s\n",V[i].cognome);
		}
}

void salva(socio *V,int n)
{ FILE *pf;
  int i;
  char data[11];

  pf=fopen("socio.dat","w");
  if(pf==NULL)
	return ;
  printf("quale data?\n");
  scanf("%s",data);

  for(i=0;i<n;i++)
	if(strcmp(V[i].data,data)<0)
		fwrite(&V[i],sizeof(socio),1,pf);
  fclose(pf);
}


void visualizza_file()
{
	FILE *pf;
	socio S;
	int i=0;

	pf=fopen("socio.dat","r");
	if(pf==NULL)
		printf("ERRORE IN LETTURA");
  	return;

	while(fread(&S,sizeof(socio),1,pf))
	  {
		printf("Nome: %s\n",S.nome);
	    printf("Cognome: %s\n",S.cognome);
		printf("N. tessera: %d\n",S.ntessera);
	    printf("Categoria: %d\n",S.categoria);
	    printf("Data: %s\n\n",S.data);
	  }


  fclose(pf);
  }


void menu( )
{
	printf("Scegli tra:\n1) inserisci\n2) visualizza\n3) salva\n4) leggi_file\n0) esci\n\n");
}








