/*
Scrivere un programma per la gestione delle informazioni relative ai dipendenti di un'azienda. Ciascun dipendente  caratterizzato dalle seguente informazioni: nominativo del componente codice mansione,  data di nascita (aaaa/mm/gg),  classe stipendiale.
Nel programma e' presente un men caratterizzato dalle seguenti funzioni:
 1) Inserimento di un nuovo dipendente;
 2) Visualizzazione del nominativo e il codice mansione dei dipendenti di una classe stipendiale;
 3) Salvataggio su file dei dipendenti con un certo codice mansione;

Si assuma che all'avvio del programma vengano lette da file le informazioni, relative ai dipendenti, precedentemente salvate.

*/

# include <stdio.h>

typedef struct
{
	char nome [40];
	int cod_mansione;
	char data_nascita [30];
	int classe_stip;
} dipendente;

void leggi (dipendente *pd);
void inserimento (dipendente *V, int *pn, dipendente d);
void visualizza (dipendente *V, int n);
void salva (dipendente *V, int n);
void menu ();
void inizializza (dipendente *V, int *pn);

int main ()
{
	dipendente A[10],d;
	int num=0,scelta;


	inizializza (A,&num);
	do
	{
		menu ();
		printf ("scelta:\n");
		scanf ("%d",& scelta);
		switch (scelta)
		{
			case 1: leggi (&d);
					inserimento (A,&num,d);
					break;
			case 2: visualizza (A,num);
					break;
			case 3: salva (A,num);
					break;
			default:;
		}
	}
	while (scelta!=0);
}


void inserimento (dipendente *V, int *pn, dipendente d)
{
	if (*pn<10)
		{
			V[*pn]=d;
			(*pn)++;
		}
	else
		printf ("Vettore pieno\n");
}

void leggi (dipendente *pd)
{
	printf ("Nome: ");
	scanf ("%s", pd->nome);
	printf ("Codice mansione: ");
	scanf ("%d",& pd->cod_mansione);
	printf ("Data nascita: ");
	scanf ("%s", pd->data_nascita);
	printf ("Classe stipendiale:\n");
	scanf ("%d",& pd->classe_stip);
}

void salva (dipendente *V, int n)
{
	FILE *pf;
	int i,cod;
	pf=fopen ("dipendente.txt","w");
	if (pf==NULL)
		return;
	printf ("Codice mansione:\n");
	scanf ("%d",& cod);
	for (i=0;i<n;i++)
		if (cod==V[i].cod_mansione)
			fwrite (&V[i],sizeof(dipendente),1,pf);
	fclose (pf);
}

void inizializza (dipendente *V, int *pn)
{
	FILE *pf;
	int i=0;
	pf=fopen ("dipendente.txt","r");
	if (pf==NULL)
		return;
	while (fread (&V[i],sizeof(dipendente),1,pf)!=0)
		i++;
	(*pn)=i;
	fclose (pf);
}

void visualizza (dipendente *V, int n)
{
	int i,classe;
	printf ("classe stipendiale:\n");
	scanf ("%d",&classe);
	for (i=0;i<n;i++)
		if (classe==V[i].classe_stip)
			{
				printf ("nome: %s\n", V[i].nome);
				printf ("cod.mansione: %d\n", V[i].cod_mansione);
			}
}

void menu ()
{
	printf ("scegli una delle seguenti opzioni\n");
	printf ("1 inserimento\n");
	printf ("2 visualizza\n");
	printf ("3 salva\n");
	printf ("0 fine programma\n");
}



